﻿Public Class PR_spec

#Region "Open, close, and Browse Button"

    Private Sub PR_spec_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Call Form_init()
    End Sub

    Private Sub PR_database_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Database_Browse_Button.Click
        Dim PR_data_view As New PR_dataview
        PR_data_view.ShowDialog()

    End Sub

    Private Sub PR_close_button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_close_button.Click
        Me.Hide()
    End Sub

    Public Sub Close_me()
        Me.Hide()
    End Sub

#End Region

#Region "initialization"

    Sub Form_init()
        Name_TextBox.Text = Derived.enclosure.PR.Name
        Fs_TextBox.Text = Str(Derived.enclosure.PR.Fs)
        PR_Vas_TextBox.Text = Str(Derived.enclosure.PR.Vas)
        Rms_TextBox.Text = Str(Derived.enclosure.PR.Rms)
        PR_Sd_TextBox.Text = Str(Derived.enclosure.PR.Sd)
        Mms_TextBox.Text = Str(Derived.enclosure.PR.Mms)
        Cms_TextBox.Text = Str(Derived.enclosure.PR.Cms)
        Qms_TextBox.Text = Str(Derived.enclosure.PR.Qms)
        Mms_TextBox.Text = Str(Derived.enclosure.PR.Mms)
        Xmax_TextBox.Text = Str(Derived.enclosure.PR.Xmax)
    End Sub
#End Region

#Region "Textboxes"

    Private Sub Vas_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Vas_TextBox.TextChanged
        Dim Vas_temp As Double
        Vas_temp = Val(PR_Vas_TextBox.Text)
        If PR_Vas_TextBox.Focused Then

            Vas_temp = Convert_to_Liters(Vas_temp, Box_model.PR_vol_Units_Flag)  'convert to common units
            Select Case Box_model.Selected_Driver
                Case Box_model.Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Vas = Vas_temp
                Case Box_model.Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Vas = Vas_temp
                Case Box_model.Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Vas = Vas_temp
            End Select

            'Derived.enclosure.PR.Vas = Units.Convert_to_Liters(Vas_temp, Box_model.Cabinet_vol_Units_Flag) 
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
        End If
    End Sub

    Private Sub Name_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Name_TextBox.TextChanged
        If Name_TextBox.Focused Then
            Select Case Box_model.Selected_Driver
                Case Box_model.Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Name = Name_TextBox.Text
                Case Box_model.Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Name = Name_TextBox.Text
                Case Box_model.Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Name = Name_TextBox.Text
            End Select

            'Derived.enclosure.PR.Name = Name_TextBox.Text
        End If
    End Sub

    Private Sub Fs_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Fs_TextBox.TextChanged
        Dim Fs_temp As Double
        Fs_temp = Val(Fs_TextBox.Text)
        If Fs_TextBox.Focused Then
            Select Case Box_model.Selected_Driver
                Case Box_model.Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Fs = Fs_temp
                Case Box_model.Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Fs = Fs_temp
                Case Box_model.Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Fs = Fs_temp
            End Select

            'Derived.enclosure.PR.Fs = Fs_temp
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
        End If
    End Sub

    Private Sub Sd_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Sd_TextBox.TextChanged
        Dim Sd_temp As Double
        Sd_temp = Val(PR_Sd_TextBox.Text)
        If PR_Sd_TextBox.Focused Then

            Sd_temp = Units.Convert_to_cm2(Sd_temp, Box_model.PR_SD_Units_Flag) 'convert to common units
            Select Case Box_model.Selected_Driver
                Case Box_model.Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Sd = Sd_temp
                Case Box_model.Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Sd = Sd_temp
                Case Box_model.Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Sd = Sd_temp
            End Select

            'Derived.enclosure.PR.Sd = Units.Convert_to_cm2(Sd_temp, Box_model.PR_SD_Units_Flag) 'convert to common units
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
        End If
    End Sub

    Private Sub Rms_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Rms_TextBox.TextChanged
        Dim Rms_temp As Double
        Rms_temp = Val(Rms_TextBox.Text)

        If Rms_TextBox.Focused Then
            Select Case Box_model.Selected_Driver
                Case Box_model.Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Rms = Rms_temp
                Case Box_model.Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Rms = Rms_temp
                Case Box_model.Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Rms = Rms_temp
            End Select

            'Derived.enclosure.PR.Rms = Rms_temp
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
        End If
    End Sub

    Private Sub Cms_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cms_TextBox.TextChanged
        Dim Cms_temp As Double
        Cms_temp = Val(Cms_TextBox.Text)

        If Cms_TextBox.Focused Then
            Select Case Box_model.Selected_Driver
                Case Box_model.Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Cms = Cms_temp
                Case Box_model.Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Cms = Cms_temp
                Case Box_model.Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Cms = Cms_temp
            End Select

            'Derived.enclosure.PR.Cms = Cms_temp
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
        End If
    End Sub

    Private Sub Qms_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Qms_TextBox.TextChanged
        Dim Qms_temp As Double
        Qms_temp = Val(Qms_TextBox.Text)

        If Qms_TextBox.Focused Then
            Select Case Box_model.Selected_Driver
                Case Box_model.Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Qms = Qms_temp
                Case Box_model.Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Qms = Qms_temp
                Case Box_model.Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Qms = Qms_temp
            End Select

            'Derived.enclosure.PR.Qms = Qms_temp
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
        End If
    End Sub

    Private Sub Mms_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Mms_TextBox.TextChanged
        Dim Mms_temp As Double
        Mms_temp = Val(Mms_TextBox.Text)

        If Mms_TextBox.Focused Then
            Select Case Box_model.Selected_Driver
                Case Box_model.Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Mms = Mms_temp
                Case Box_model.Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Mms = Mms_temp
                Case Box_model.Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Mms = Mms_temp
            End Select

            'Derived.enclosure.PR.Mms = Units.Convert_to_Grams(Mms_temp, Box_model.PR_Mms_Units_Flag) 'convert to common units
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
        End If
    End Sub

    Private Sub Xmax_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Xmax_TextBox.TextChanged
        Dim Xmax_temp As Double
        Xmax_temp = Val(Xmax_TextBox.Text)

        If Xmax_TextBox.Focused Then

            Select Case Box_model.Selected_Driver
                Case Box_model.Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Xmax = Xmax_temp
                Case Box_model.Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Xmax = Xmax_temp
                Case Box_model.Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Xmax = Xmax_temp
            End Select

            'Derived.enclosure.PR.Xmax = Xmax_temp
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
        End If
    End Sub

#End Region

#Region "Units Buttons"
    Private Sub PR_Vas_units_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Vas_units_Button.Click
        Call Box_model.Update_Volume_textboxes()

        'Cycles through:  Liters (L), Meters^3 (M), In^3 (I), and Ft^3 (F)
        Box_model.PR_vol_Units_Flag = Units.Next_Liters_conv_flag(Box_model.PR_vol_Units_Flag)   'figure out next unit
        PR_Vas_units_Button.Text = Units.Liters_conv_text(Box_model.PR_vol_Units_Flag)   'figure out button text
        PR_Vas_TextBox.Text = Units.Liters_to_units(Derived.enclosure.PR.Vas, Box_model.PR_vol_Units_Flag)
    End Sub

    Private Sub PR_Sd_units_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Sd_units_Button.Click
        'Cycles through:  m^2 (M), cm^2 (C)and In^2 (I)
        Box_model.PR_SD_Units_Flag = Units.Next_SD_conv_flag(Box_model.PR_SD_Units_Flag)   'figure out next unit
        PR_Sd_units_Button.Text = Units.SD_conv_text(Box_model.PR_SD_Units_Flag)   'figure out button text
        PR_Sd_TextBox.Text = Units.SD_to_units(Derived.enclosure.PR.Sd, Box_model.PR_SD_Units_Flag)
    End Sub


#End Region

End Class